from datetime import datetime

from osgeo import ogr

from ru_axioma_gis_loadOsm.ui.tools.add_helper.db.dbTools import DbTools
from ru_axioma_gis_loadOsm.ui.tools.add_helper.handlers_ogr import DbOgr
from ru_axioma_gis_loadOsm.ui.tools.add_helper.relationDb import RelationDb
from ru_axioma_gis_loadOsm.ui.tools.add_helper.relation_tools import getGeometryRelation


def updateGeometryByFid(layer,fid,geometry):
    feature = layer.GetFeature(fid)
    if feature is None:
        return False
    feature.SetGeometry(geometry)
    layer.SetFeature(feature)
    return True
path_db=r"E:\Download\OSM\osm_import\old_bounds_north-caucasus-fed-district-latest.gpkg"
path_db=r"E:\Download\OSM\osm_import\north-caucasus-fed-district-latest_osm_boundary_relation.gpkg"
osmfile =r"E:\Download\OSM\north-caucasus-fed-district-latest.osm.pbf"
path_db_relation=r"E:\Download\OSM\osm_import\relation_north-caucasus-fed-district-latest.osm.gpkg"
db_ogr=DbOgr(None)
db_ogr.open(path_db)
name_layer='data_osm'
name_layer='boundary_data'
db=DbTools(path_db)
sql="SELECT fid ,id,JSON_EXTRACT ([info_json], '$.boundary') AS boundary from data_osm where type_object=4"
sql="select fid,id,cast(JSON_EXTRACT ([info_json], '$.admin_level') AS INTEGER ) AS [admin_level]  from data_osm where osm_type='relation' and admin_level=6"
sql="select fid,id,cast(JSON_EXTRACT ([info_json], '$.admin_level') AS INTEGER ) AS [admin_level]  from boundary_data where osm_type='relation' and admin_level=6"
sql="select fid,id,cast(JSON_EXTRACT ([info_json], '$.admin_level') AS INTEGER ) AS [admin_level]  from boundary_data where osm_type='relation' and admin_level=6 and  (geom is NULL)"
layer=db_ogr.getLayer(name_layer)
#layer_sql=db_ogr.runSql(sql)
rows=db.select(sql)
db.close()
print("Start")
start_time= datetime.now()
db_relation=RelationDb(path_db_relation,osmfile,True)
db_relation.createCache()
#for ft in layer_sql:
max_feature=20
i=0
for row in rows:
    #fid=ft.GetFID()
    #id_osm=ft.GetField('id')
    i=i+1
    #if max_feature is not None and i>max_feature:
    #    break
    fid=row[0]
    id_osm=row[1]
    print("Start fid="+str(fid))
    #geo_realation=getGeometryRelation(osmfile,id_osm)
    geo_realation=db_relation.getGeometryRelation(id_osm)
    if geo_realation is None:
        continue
    ogr_geo=ogr.CreateGeometryFromWkb(geo_realation.wkb)
    updateGeometryByFid(layer,fid,ogr_geo)
    geo_realation=None
    ogr_geo=None
    print("End fid="+str(fid))
    #break
db_ogr.close()
db_relation.close()
end_time= datetime.now()
print(end_time-start_time)
print("end")