import os

import axipy
from PySide2.QtGui import QIcon
from axipy import Plugin, Position

from ru_axioma_gis_loadOsm.ui.docWidget import AxiDocWidget, addDoc, existDocWidget
from ru_axioma_gis_loadOsm.ui.main_form import MainFromOsm
from ru_axioma_gis_loadOsm.ui.tools.add_helper.property_inport import copyDefaultJson
from ru_axioma_gis_loadOsm.ui.widgetLoadOsm import DlgLoadOsm


class ImportOsm(Plugin):
    def __init__(self):
        self.__name="Импорт OSM"
        self.__form_tool = None
        self.__docWidget = None
        self._title = self.tr(self.__name)

        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'ui/icons', 'openstreetmap.png')
        self.__icon_tools=QIcon(local_file_icon_1)
        self.__action_import_osm = self.create_action(self.__name,
                                                    icon=local_file_icon_1, on_click=self.__run_import_osm)

        position = Position('Импорт-Экспорт', 'Действие')
        position.add(self.__action_import_osm)
        path_default_json=self.plugin_dir.joinpath("ui/initDataConfig")
        copyDefaultJson(path_default_json, self.get_plugin_data_dir() )
    def __run_import_osm(self):
        if self.__form_tool is None:
            #self.__form_tool = DlgLoadOsm(self, axipy.mainwindow.qt_object())
            self.__form_tool = MainFromOsm(self, axipy.mainwindow.qt_object())
        if self.__docWidget is None:

            self.__docWidget = AxiDocWidget(self.__form_tool.widget, self.__name, self.__name,
                                            self.__icon_tools, axipy.view_manager.global_parent)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
        else:
            isExist = existDocWidget(axipy.view_manager.global_parent, self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def unload(self) -> None:
        self.__action_import_osm.remove()
        if self.__docWidget is not None:
            #DelDocWidget(axipy.mainwindow.qt_object(),self.__docWidget)
            axipy.mainwindow.qt_object().removeDockWidget(self.__docWidget)
            self.__form_tool=None
            self.__docWidget=None

