import xmltodict
from OSMPythonTools.api import Api
def xml_dict_relationPoints(xml_obj):
    rel_obj=xmltodict.parse(xml_obj)
    obj_nodes=rel_obj['osm']['node']
    dict_nodes={}
    for node in obj_nodes:
        id=node['@id']
        lat=node['@lat']
        lon=node['@lon']
        dict_nodes[id]={'x':float(lon),'y':float(lat)}
    obj_way=rel_obj['osm']['way']
    points=[]
    for way in obj_way:
        id_way=way['@id']
        points_way=[]
        points.append({'way_id':way['@id'],"points":points_way})
        for nd in way['nd']:
            id_node=nd['@ref']
            node_temp=dict_nodes[id_node]
            points_way.append(node_temp)
            jkl=0
    return points
def xml_dict_way(xml_obj):
    object=xmltodict.parse(xml_obj)
    jkl=0

    obj_nodes = object['osm']['node']
    dict_nodes = {}
    for node in obj_nodes:
        id = node['@id']
        lat = node['@lat']
        lon = node['@lon']
        dict_nodes[id] = {'x': float(lon), 'y': float(lat)}

    points = []


    for nd in object['osm']['way']['nd']:
        id_node = nd['@ref']
        node_temp = dict_nodes[id_node]
        points.append(node_temp)

    return points
class OSMPythonToolsObject:
    def __init__(self):
        self.__api = Api()
    def getGeometryRelation(self,id):
        way = self.__api.query('relation/'+str(id))
        dict_1 = xmltodict.parse(way._xml)
        points=[]
        all_points=0
        for member in dict_1['osm']['relation']['member']:
            if member['@role']=='label':
                continue
            id_object=member['@ref']
            #print(id_object)
            type_object=member['@type']
            point_obj_ref=self.__getObjectInfoPoints(id_object,type_object)
            if point_obj_ref is not None:
                print("ID ="+str(id_object)+" Count points:"+str(len(point_obj_ref)))
                all_points=all_points+len(point_obj_ref)
                #points.extend(point_obj_ref)
                points.append({'way':id_object,"points":point_obj_ref})
        print("All points="+str(all_points))
        return points
    def __getObjectInfoPoints(self,id,type):
        points=[]
        query=type+"/"+id
        if type=='way':
            query=query+"/full"
        obj_info=self.__api.query(query)
        if obj_info is None:
            return None
        xml_obj=obj_info.toXML()
        #dict_obj=xmltodict.parse(xml_obj)
        points=xml_dict_way(xml_obj)
        return points


