import json
import os
import shutil
from pathlib import Path


class PropertyImportItem:
    def __init__(self):
        self.enable=False
        self.style="Symbol (35, 0, 12)"
class PropertyPoint(PropertyImportItem):
    def __init__(self):
        super().__init__()
        self.style="Pen (1, 2, 0)"

class PropertyWay(PropertyImportItem):
    def __init__(self):
        super().__init__()
        self.style = "Pen (1, 2, 0) Brush (1, 16777215, 16777215)"
        self.polygon = False
class PropertyArea(PropertyImportItem):
    def __init__(self):
        super().__init__()

class RpopertyImport:
    def __init__(self,name_layer,cls_point,cls_way,cls_area,cls_relation,base_tag,sql_view):
        self.name_layer=name_layer
        self.point=cls_point
        self.way=cls_way
        self.area=cls_area
        self.relation=cls_relation
        self.base_tag=base_tag
        self.sql_view=sql_view
def factoryRpopertyImport(js_obj_data):
    if isinstance(js_obj_data,dict):
        js_obj=js_obj_data
    else:
        with open(js_obj_data, encoding='utf-8') as fh:
            js_obj = json.load(fh)

    objects=js_obj['object_type']
    obj_point=objects['point']
    obj_relation=objects['relation']
    cls_point=PropertyPoint()
    setattr(cls_point, 'style',obj_point['style'])
    name_layer=objects['name_layer']
    enable=False
    if obj_point['enable'].lower()=="true":
        enable = True
    setattr(cls_point, 'enable', enable)
    obj_way=objects['line']
    cls_way=PropertyWay()
    setattr(cls_way, 'style', obj_point['style'])
    enable = False
    if obj_way['enable'].lower() == "true":
        enable = True
    setattr(cls_way, 'enable', enable)
    enable = False
    if obj_way['polygon'].lower() == "true":
        enable = True
    setattr(cls_way, 'polygon', enable)
    obj_area=objects['polygon']
    cls_area=PropertyArea()
    setattr(cls_area, 'style', obj_area['style'])
    enable = False
    if obj_area['enable'].lower() == "true":
        enable = True
    setattr(cls_area, 'enable', enable)
    cls_relation=PropertyPoint()
    if obj_relation['enable'].lower()=="true":
        enable = True
    setattr(cls_relation, 'enable', enable)
    obj_filter_tag=objects['filter_tag']
    value_base_tag=obj_filter_tag['base_tag']
    sql_view=None
    try:
        sql_view=objects['default_view']
    except:
        pass
    return RpopertyImport(name_layer,cls_point,cls_way,cls_area,cls_relation,value_base_tag,sql_view)
def copyDefaultJson(path_source,path_dest):
    if isinstance(path_source,str):
        folder_source=Path(path_source)
    else:
        folder_source=path_source
    if isinstance(path_dest,str):
        folder_dest=Path(path_dest)
    else:
        folder_dest=path_dest
    for (root, dirs, file) in os.walk(str(path_source)):
        for f in file:
            if '.json' in f:
                full_path_source=folder_source.joinpath(f)
                full_path_dest = folder_dest.joinpath(f)
                if full_path_dest.exists():
                    continue
                shutil.copy2(str(full_path_source),str(full_path_dest))

def loadAllPropery(path_data):
    if isinstance(path_data, str):
        folder_source = Path(path_data)
    else:
        folder_source = path_data
    list_property= {}

    for (root, dirs, file) in os.walk(str(folder_source)):
        for f in file:
            if '.json' in f:
                full_path_source = folder_source.joinpath(f)
                osm_imp_property=factoryRpopertyImport(str(full_path_source))
                if osm_imp_property is not None:
                    list_property[osm_imp_property.base_tag]=osm_imp_property
    if len(list(list_property.keys()))==0:
        return None
    return list_property

