import binascii
import os
from pathlib import Path
import osmium as o
import shapely
from osmium import NodeLocationsForWays
from osmium.index import create_map
from osmium.io import Reader
from shapely import LineString, multilinestrings, line_merge
from shapely.geometry import linestring

from ru_axioma_gis_loadOsm.ui.tools.add_helper.db.dbTools import DbTools
geowkbfab = o.geom.WKBFactory()
def createShapelyGeometry(str_geo):
    byte_geo_obj = binascii.unhexlify(str_geo)
    # poly = wkblib.loads(wkb, hex=True)
    ogr_geo = shapely.from_wkb(byte_geo_obj)
    return ogr_geo
class IDCollectorRelationCache:

    def __init__(self,idx):
        self.idx=idx
        self.nodes = {}
        self.ways = []
        self.relations = []
        self.area=[]
        self.changesets = []

    def node(self, n):
        #self.nodes.append(n.id)
        #wkb=geowkbfab.create_point(n)
        #geo=createShapelyGeometry(wkb)
        #self.nodes.append({'id':n.id,'x':n.lon,'y':n.lat})
        self.nodes[n.id]={'id':n.id,'x':n.lon,'y':n.lat}

    def way(self, w):
        #self.ways.append(w.id)
        id_nodes=[]
        self.ways.append({'id': w.id, 'nodes': id_nodes})
        for n in w.nodes:
            loc = self.idx.get(n.ref)  # note that cache is used here
            jkl=0

        for node in w.nodes:
            id_nodes.append(node.ref)
    def area(self,w):
        self.area(w.id)
    def relation(self, r):
        #self.relations.append(r.id)
        list_id_children=[]
        self.relations.append({'id':r.id,"children":list_id_children})
        for mem in r.members:
            if mem.role=='label':
                continue
            list_id_children.append(mem.ref)


    def changeset(self, c):
        self.changesets.append(c.id)

class IDCollectorRelation:

    def __init__(self):
        self.nodes = {}
        self.ways = []
        self.relations = []
        self.area=[]
        self.changesets = []

    def node(self, n):
        #self.nodes.append(n.id)
        #wkb=geowkbfab.create_point(n)
        #geo=createShapelyGeometry(wkb)
        #self.nodes.append({'id':n.id,'x':n.lon,'y':n.lat})
        self.nodes[n.id]={'id':n.id,'x':n.lon,'y':n.lat}

    def way(self, w):
        #self.ways.append(w.id)
        id_nodes=[]
        self.ways.append({'id': w.id, 'nodes': id_nodes})
        for node in w.nodes:
            id_nodes.append(node.ref)
    def area(self,w):
        self.area(w.id)
    def relation(self, r):
        #self.relations.append(r.id)
        list_id_children=[]
        self.relations.append({'id':r.id,"children":list_id_children})
        for mem in r.members:
            if mem.role=='label':
                continue
            list_id_children.append(mem.ref)


    def changeset(self, c):
        self.changesets.append(c.id)

def getMembersRelationCache(path_osm,id_relation):
    ids = IDCollectorRelation()
    reader = Reader(path_osm)
    #idx='flex_mem'
    #lh = NodeLocationsForWays(create_map(idx))
    #lh.ignore_errors()
    # o.apply(reader, o.filter.IdFilter([1023458274, 1023458275,413084041]), ids)
    if isinstance(id_relation,list):
        o.apply(reader, o.filter.IdFilter(id_relation), ids)
    else:
        o.apply(reader, o.filter.IdFilter([id_relation]), ids)
    #if len(ids.relations)==0:
    #    return None
    return ids
def getMembersRelation(path_osm,id_relation):
    ids = IDCollectorRelation()
    reader = Reader(path_osm)
    #idx='flex_mem'
    #lh = NodeLocationsForWays(create_map(idx))
    #lh.ignore_errors()
    # o.apply(reader, o.filter.IdFilter([1023458274, 1023458275,413084041]), ids)
    if isinstance(id_relation,list):
        o.apply(reader, o.filter.IdFilter(id_relation), ids)
    else:
        o.apply(reader, o.filter.IdFilter([id_relation]), ids)
    #if len(ids.relations)==0:
    #    return None
    return ids

def getGeometryRelation(path_osm,id_relation):
    ids=getMembersRelation(path_osm,id_relation)
    if len(ids.relations)==0:
        return None
    list_way=ids.relations[0]['children']
    ids_way=getMembersRelation(path_osm,list_way)
    geo_objects=[]
    for way in ids_way.ways:
        sort_list=way['nodes'].copy()
        sort_list.sort()
        list_nodes=getMembersRelation(path_osm,sort_list)
        if len(list_nodes.nodes)==0:
            continue
        points=[]
        for id_node in way['nodes']:
            node=list_nodes.nodes[id_node]
            points.append((node['x'],node['y']))
        if len(points)>0:
            geo_objects.append(LineString(points))
    if len(geo_objects)==0:
        return None
    if len(geo_objects)==1:
        return geo_objects[0]
    geo_multi_linestring=multilinestrings(geo_objects)
    return line_merge(geo_multi_linestring)
    #return geo_objects
class ObjectRelationa:
    def __init__(self,path_osm,path_gpkg):
        self.__path_osm=path_osm
        self.__path_gpkg=path_gpkg
    def __initTempDb(self):
        path_folder=Path(__file__).parent
        path_temp_db=path_folder.joinpath("temp_relation.gpkg")
        if path_temp_db.exists():
            os.remove(path_temp_db)
        self.__db_relation=DbTools(str(path_temp_db))